<template>
  <Fragment>
    <ListItem v-d-flex>
      <div :style="{width: `${(level + 1) * 16}px`, paddingRight: '4px'}" />
      <Checkbox
        v-model="permission.checked"
        v-grow
        :label="permission.name"
        :is-indeterminate="permission.isIndeterminate"
        @click="changePermission(permission.index)"
      />
    </ListItem>
    <NestedPermission
      v-for="child in children"
      :key="child.id"
      :permission="child"
      :level="level + 1"
    />
  </Fragment>
</template>

<script lang="ts">
import {
  Component, Inject, InjectReactive, Prop, Vue,
} from 'vue-property-decorator';
// @ts-ignore
import { Fragment } from 'vue-fragment';
import { IPermission, IPermissionTree } from '@/interfaces/models/IPermission';
import ListItem from '@/components/listItem/ListItem.vue';
import Checkbox from '@/components/form/checkbox/Checkbox.vue';

@Component({
  name: 'NestedPermission',
  components: {
    Checkbox,
    ListItem,
    Fragment,
  },
})
export default class NestedPermission extends Vue {
  @Prop()
  permission!: IPermission;

  @Prop({ default: () => 0 })
  level!: number;

  @InjectReactive('permissionsTree')
  tree!: IPermissionTree;

  @InjectReactive('changePermission')
  changePermission!: (index: number) => void;

  get children() {
    return this.tree[this.permission.index];
  }
}
</script>
